option add Rtp_play.colorModel "best" startupFile

#
# print out gob and macroblock number (starting from 0 not 1)
# XXX assumes CIF
#
proc putinfo { x y } {
	global width height

	if {[decoder format] == "cif"} {
		set x [expr $x * 352 / $width]
		set y [expr $y * 288 / $height]

		set h [expr int($x / 176)]
		set v [expr int($y / 48)]
		set gob [expr $h + 2 * $v]

		set x [expr $x - $h * 176]
		set y [expr $y - $v * 48]
		set h [expr int($x / 16)]
		set v [expr int($y / 16)]
		set mba [expr $h + 11 * $v]
		set blk 0
	} else {
		set x [expr $x * 176 / $width]
		set y [expr $y * 144 / $height]

		set h [expr int($x)]
		set v [expr int($y)]

		set gv [expr int($v / 48)]
		set gob [expr $gv]
		set v [expr $v - $gv*48]

		set mv [expr int($v / 16)]
		set mh [expr int($h / 16)]
		set mba [expr $mv*11 + $mh]

		set bh [expr int(($h - $mh*16) / 8)]
		set bv [expr int(($v - $mv*16) / 8)]
		set blk [expr $bv * 2 + $bh + 1]
	}
	puts stderr "p [decoder frame]  g $gob  m $mba  b $blk"
}

proc build { w h } {
	global width height
	set width $w
	set height $h
	video .video $width $height
	pack append . .video { top }

	bind .video <Enter> { focus %W }
	bind .video <Return> { decoder next }
	bind .video <p> { decoder nextpacket }
	bind .video <1> { putinfo %x %y }
	bind .video <space> run
	bind .video <q> exit
	bind .video <d> { decoder dump t.ppm }
	bind .video <f> { puts [decoder frame] }

	return .video
}
set running 0
proc run { } {
	global running
	if { !$running } {
		set running 1
		after 0 tick
	} else {
		# race
		set running 0
	}
}
proc tick { } {
	decoder next
	update idletasks
	global running
	if { $running } {
		after 0 tick
	}
}
